diff --git a/base/tps-tomcat/src/org/dogtagpki/server/tps/processor/TPSProcessor.java b/base/tps-tomcat/src/org/dogtagpki/server/tps/processor/TPSProcessor.java
index 4efb2fb..df312d1 100644
--- a/base/tps-tomcat/src/org/dogtagpki/server/tps/processor/TPSProcessor.java
+++ b/base/tps-tomcat/src/org/dogtagpki/server/tps/processor/TPSProcessor.java
@@ -1464,6 +1563,123 @@ public class TPSProcessor {
 
     }
 
+    protected AppletInfo getAppletInfo() throws TPSException, IOException {
+        AppletInfo result = null;
+
+        CMS.debug("TPSProcessor.getAppletInfo, entering ...");
+        TPSBuffer aidBuf = getCardManagerAID();
+
+        APDUResponse select = selectApplet((byte) 0x04, (byte) 0x00, aidBuf);
+
+        if (!select.checkResult()) {
+            throw new TPSException("TPSProcessor.getAppletInfo: Can't selelect the card manager!");
+        }
+
+        TPSBuffer cplc_data = getCplcData();
+        CMS.debug("cplc_data: " + cplc_data.toString());
+
+        TPSBuffer token_cuid = extractTokenCUID(cplc_data);
+        TPSBuffer token_msn = extractTokenMSN(cplc_data);
+
+        /**
+         * Checks if the netkey has the required applet version.
+         */
+
+        TPSBuffer netkeyAid = getNetkeyAID();
+
+        // We don't care if the above fails now. getStatus will determine outcome.
+
+        select = selectApplet((byte) 0x04, (byte) 0x00, netkeyAid);
+
+        TPSBuffer token_status = getStatus();
+
+        byte major_version = 0x0;
+        byte minor_version = 0x0;
+        byte app_major_version = 0x0;
+        byte app_minor_version = 0x0;
+
+        CMS.debug("TPS_Processor.getAppletInfo: status: " + token_status.toHexString());
+        if (token_status.size() >= 4) {
+            major_version = token_status.at(0);
+            minor_version = token_status.at(1);
+            app_major_version = token_status.at(2);
+            app_minor_version = token_status.at(3);
+        }
+
+        result = new AppletInfo(major_version, minor_version, app_major_version, app_minor_version);
+        result.setCUID(token_cuid);
+        result.setMSN(token_msn);
+
+        CMS.debug("TPSProcessor.getAppletInfo: cuid: " + result.getCUIDString() + " msn: " + result.getMSNString()
+                + " major version: " + result.getMinorVersion() + " minor version: " + result.getMinorVersion()
+                + " App major version: " + result.getAppMajorVersion() + " App minor version: "
+                + result.getAppMinorVersion());
+
+        return result;
+    }
+
+    protected boolean checkSymmetricKeysEnabled() throws TPSException {
+        boolean result = true;
+
+        IConfigStore configStore = CMS.getConfigStore();
+
+        String symmConfig = "op" + "." + currentTokenOperation + "." + selectedTokenType + "."
+                + TPSEngine.CFG_SYMM_KEY_UPGRADE_ENABLED;
+
+        try {
+            result = configStore.getBoolean(symmConfig, true);
+        } catch (EBaseException e) {
+            throw new TPSException("TPSProcessor.checkSymmetricKeysEnabled: Internal error getting config value.");
+        }
+
+        return result;
+    }
+
+    protected SecureChannel checkAndUpgradeSymKeys() throws TPSException, IOException {
+
+        SecureChannel channel = null;
+
+        if (checkSymmetricKeysEnabled()) {
+            //To be implemented later
+            throw new TPSException("TPSProcessor.checkAndUpgradeSymKeys: Key changeover not yet implemented!",
+                    TPSStatus.STATUS_ERROR_MISCONFIGURATION);
+
+        } else {
+            //Create a standard secure channel with current key set.
+            CMS.debug("TPSProcessor.checkAndUpgradeSymKeys: Key changeover disabled in the configuration.");
+
+            int defKeyVersion = getChannelDefKeyVersion();
+            int defKeyIndex = getChannelDefKeyIndex();
+
+            channel = setupSecureChannel((byte) defKeyVersion, (byte) defKeyIndex, SecurityLevel.SECURE_MSG_MAC_ENC,
+                    getTKSConnectorID());
+
+        }
+
+        return channel;
+    }
+
+    //List objects that may be on a given token
+    //Return null if object void of objects
+
+    protected TPSBuffer listObjects(byte seq) throws TPSException, IOException {
+        TPSBuffer objects = null;
+
+        ListObjectsAPDU listObjects = new ListObjectsAPDU(seq);
+
+        APDUResponse respApdu = handleAPDURequest(listObjects);
+
+        if (!respApdu.checkResult()) {
+            CMS.debug("TPSProcessor.listObjects: Bad response from ListObjects! Token possibly has no objects");
+            return null;
+        }
+
+        objects = respApdu.getData();
+
+        return objects;
+
+    }
+
     public static void main(String[] args) {
     }
 
diff --git a/base/tps-tomcat/src/org/dogtagpki/server/tps/profile/MappingTokenProfileResolver.java b/base/tps-tomcat/src/org/dogtagpki/server/tps/profile/MappingTokenProfileResolver.java
index 91542b8..264fba8 100644
--- a/base/tps-tomcat/src/org/dogtagpki/server/tps/profile/MappingTokenProfileResolver.java
+++ b/base/tps-tomcat/src/org/dogtagpki/server/tps/profile/MappingTokenProfileResolver.java
@@ -1,9 +1,8 @@
 package org.dogtagpki.server.tps.profile;
 
-import java.lang.Integer;
 import org.dogtagpki.server.tps.engine.TPSEngine;
 import org.dogtagpki.tps.main.TPSException;
-import org.dogtagpki.tps.msg.EndOp.TPSStatus;
+import org.dogtagpki.tps.msg.EndOpMsg.TPSStatus;
 
 import com.netscape.certsrv.apps.CMS;
 import com.netscape.certsrv.base.EBaseException;
diff --git a/base/tps-tomcat/src/org/dogtagpki/server/tps/profile/TokenProfileParams.java b/base/tps-tomcat/src/org/dogtagpki/server/tps/profile/TokenProfileParams.java
index 1dda47a..d04bc9f 100644
--- a/base/tps-tomcat/src/org/dogtagpki/server/tps/profile/TokenProfileParams.java
+++ b/base/tps-tomcat/src/org/dogtagpki/server/tps/profile/TokenProfileParams.java
@@ -21,9 +21,10 @@ import java.util.HashMap;
 import java.util.Map;
 import java.util.Set;
 
-import com.netscape.certsrv.apps.CMS;
 import org.dogtagpki.tps.main.TPSException;
-import org.dogtagpki.tps.msg.EndOp.TPSStatus;
+import org.dogtagpki.tps.msg.EndOpMsg.TPSStatus;
+
+import com.netscape.certsrv.apps.CMS;
 
 /**
  * A class represents profile params information.
-- 
1.8.3.1

